<%@page contentType="text/html"%>
<%@page pageEncoding="UTF-8"%>
<%@page import="java.io.FileInputStream"%>
<%@page import="java.util.Properties"%>
<%@page import="com.swiveltechnologies.client.PINsafeClient"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
   "http://www.w3.org/TR/html4/loose.dtd">
 <%

    final String USERNAME_PROMPT = "Step 1: Enter your username and<br>press the Security String button if you need a TURing image";
	final String CURRENT_OTC_PROMPT = "Step 2 : Enter the OTC (one-time-code) using the PIN<br>your current PIN and the Security String shown below.";
	final String NEW_OTC_PROMPT = "Step 3 : Enter the OTC using your<br>new PIN and the Security String.";
	final String CONFIRM_OTC_PROMPT = "Step 4 : Re-enter the OTC using your new PIN";
	final String CLICK_BUTTON_PROMPT = "<br/>then click on Change PIN button";

	final String PASSWORD_PROMPT = "Step 2a: If your PINsafe has a password, enter it here:";
	final String NEW_PASSWORD_PROMPT = "Step 5: If you are also changing your PINsafe password<br /> Enter New Password:";
	final String CONFIRM_PASSWORD_PROMPT = "Step 6: Re-enter your new password";
	
	final String PIN_CHANGE_SUCCESSFUL = "PIN change successful.<br>";
	final String REDIRECTING_PROMPT = "Please wait while you are redirected. If your<br>browser doesn't automatically redirect <br/>click";
	final String REDIRECT_LINK_PROMPT = "here";
	final String REDIRECTING_PROMPT2 = "to continue.";
	
	final String CURRENT_PIN_PROMPT = "Enter your current PIN";
	final String NEW_PIN_PROMPT = "Enter your new PIN";
	final String CONFIRM_PIN_PROMPT = "Confirm your new PIN";

	final String DEFAULT_ERROR = "An error occured, please check your<br />credentials. If the error persists<br /> contact your PINsafe Administrator.";
	final String INVALID_PIN_ERROR = "Your chosen PIN was not valid.<br />Please try again with a different PIN.<br />For more details contact your PINsafe Administrator";
	final String INVALID_PASSWORD_ERROR = "Your chosen Password was not valid.<br />Please try again with a different Password.<br />For more details contact your PINsafe Administrator";
	final String SESSION_START_ERROR = "Cannot start PINsafe Session";
	final String INVALID_USERNAME_ERROR = "Invalid Characters in username";
	final String PASSWORD_REQUIRED_ERROR = "You must supply a valid password";
	
   final String errorAttribute = "error";
   final String usernameAttribute ="username";
   final String sessionidAttribute = "sessionid";
   final String passwordAttribute = "password";
   
   int init = 0, sessionStart = 1, changePin = 2, complete = 3;
   int status= changePin;

   String password = "", newPassword="", otc = "", newotc= "", error="", sessionID = "", username = "";
   String OTC = "", newOTC = "";

   Properties clientProps = new Properties();
//   Properties sessionProps = new Properties();

   if(session.getAttribute("status") == null){
   	status = init;
   }else {
   	if ((request.getParameter("sessionstart") != null) || new String("sessionstart").equals(request.getParameter("action"))) {
      		status = sessionStart;
   	}
   }

   session.setAttribute("status", status);

   try {
	    FileInputStream is = new FileInputStream(
	            this.getServletContext().getRealPath("/WEB-INF/settings.xml"));
	    clientProps.loadFromXML(is);
	} catch (Exception e) {
		error = e.getLocalizedMessage();
		
	} finally {
	session.setAttribute("settings", clientProps);
	}
	// read any parameters passed into the page
	// only allow username to passed in a GET
	username = (request.getParameter(usernameAttribute) != null ? request.getParameter(usernameAttribute) : "");
	username = (PINsafeClient.checkChars(username)? username : "");
	//
	if(request.getMethod().equalsIgnoreCase("POST")){
	password = (request.getParameter(passwordAttribute) != null ? request.getParameter(passwordAttribute) : "");
	if(clientProps.getProperty("password","false").equalsIgnoreCase("true")){
		password = (request.getParameter("password") != null ? request.getParameter("password") : "");
	}
	
	if(clientProps.getProperty("changepassword","false").equalsIgnoreCase("true")){
		newPassword = (request.getParameter("newpassword") != null ? request.getParameter("newpassword") : "");
	}
	
	    
	    OTC = (request.getParameter("otc") != null ? request.getParameter("otc") : "");
	    newOTC = (request.getParameter("newotc") != null ? request.getParameter("newotc") : "");
	}
	    if(username.equals("")) {
	    	status = init;
	    }
	//Check to see what prompts are required.
	String existingPrompt, newOTCPrompt, confirmNewOTCPrompt;

	boolean explicit = false;
	if(clientProps.getProperty("explicit", "false").equalsIgnoreCase("true"))
	{
		explicit = true;
		existingPrompt = CURRENT_PIN_PROMPT;
		newOTCPrompt = NEW_PIN_PROMPT;
		confirmNewOTCPrompt = CONFIRM_PIN_PROMPT;
	} else {

		existingPrompt = CURRENT_OTC_PROMPT;
		newOTCPrompt = NEW_OTC_PROMPT;
		confirmNewOTCPrompt = CONFIRM_OTC_PROMPT;
		if(!clientProps.getProperty("changepassword", "false").equalsIgnoreCase("true")){
			confirmNewOTCPrompt = confirmNewOTCPrompt.concat(CLICK_BUTTON_PROMPT);
		}
		
	}
	PINsafeClient sc;
	switch (status){
		
case(1):

	 sc = new PINsafeClient(clientProps);
	    //Create an instance of the PINsafeClient and setup with he settings...
        if(PINsafeClient.checkChars(username)){
        
        //Attempt to create a session...
        sessionID = sc.startSession(username);
        
        if(sessionID.length() == 0){
        	error = SESSION_START_ERROR;
        	session.setAttribute("error", error);
        	} else {
        		error = "";
        	}
        } else {
        	error = INVALID_USERNAME_ERROR;
        }

	break;
	
case(2):
{
	 sc = new PINsafeClient(clientProps);
	if(explicit) {
    	  sessionID = sc.startSession(username);
          String security = sc.getSecurityString(sessionID);
            if (!security.equals("")) {
                security = security + "0";
                String pin = OTC.concat("0");
                String newpin = newOTC.concat("0");
                //      determine one-time-code
                OTC = new String("");
                for (int c = 0; c < pin.length() - 1; c++) {
                    int index = Integer.parseInt(pin.substring(c, c+ 1));
                if (index == 0)
                    index = 9;
                        else
                    index--;
                OTC += security.substring(index, index + 1);
              }
                //determine new one-time-code
                newOTC = new String("");
                for (int c = 0; c < newpin.length() - 1; c++) {
                    int index = Integer.parseInt(newpin.substring(c, c + 1));
                    if (index == 0)
                        index = 9;
                    else
                        index--;
                    newOTC += security.substring(index, index + 1);
                }
            }
	}//end of explicit block
        //If no new password is entered, submit old
        if(newPassword.equals("")){
        	newPassword = password;
        }
    if (sc.changePIN(username, password, newPassword, OTC, newOTC)) {
    	status = complete;
    	session.setAttribute("status", init);
    	error = "";
    } else {
            //Redirect user with error and username...
			error = sc.getError();
			if(error.toLowerCase().contains("composition")){
				if(error.toLowerCase().contains("pin")){
					error = INVALID_PIN_ERROR;
				}else {
					error = INVALID_PASSWORD_ERROR;
				}
			} else { 
				if(error.toLowerCase().contains("password_mandatory")) {
					error = PASSWORD_REQUIRED_ERROR;
				} else {
				error = DEFAULT_ERROR;
				}
    	}
    }
}//end of changePIUN case
}// end of switch

%>

<%if(status != complete)  {%>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<link type="text/css" rel="stylesheet" href="./changepin.css">
<title>PINsafe Change PIN</title>
<script type="text/javascript" src="./changepin.js"></script>
</head>
<body onload="enable_buttons(); set_focus();">
<form method="post" id="changepin-form"
	onkeypress="return handle_enter(event);" onkeyup="enable_buttons();"
	action="changepin.jsp"><input type="hidden" name="action"
	id="action" />
<table id="box">
	<tr id="username-row">
		<td class="label"><%=USERNAME_PROMPT%></td>
		<td class="text"><input name="username" id="username" type="text"
			value="<%=username%>"></td>
	</tr>
	<tr id="otc-row">
		<td class="label"><%=existingPrompt%></td>
		<td class="text"><input name="otc" id="otc" type="password"></td>
	</tr>
	<%if(clientProps.getProperty("password", "false").equalsIgnoreCase("true"))
                {%>
	<tr id>
		<td class="label"><%=PASSWORD_PROMPT%></td>
		<td class="text"><input name="password" id="password"
			type="password" value=""></td>
	</tr>
	<% } %>
	
	<tr>
		<td class="label"><%=newOTCPrompt%></td>
		<td class="text"><input name="newotc" id="newotc"
			type="password"></td>
	</tr>
	<tr>
		<td class="label"><%=confirmNewOTCPrompt%></td>
		<td class="text"><input name="newotc2" id="newotc2"
			type="password"></td>
	</tr>
	<%
	if(clientProps.getProperty("changepassword", "false").equalsIgnoreCase("true"))
                {%>
	<tr id>
		<td class="label"><%=NEW_PASSWORD_PROMPT%></td>
		<td class="text"><input name="newpassword" id="newpassword"
			type="password"></td>
	</tr>
	<tr id>
		<td class="label"><%=CONFIRM_PASSWORD_PROMPT%><%=CLICK_BUTTON_PROMPT%></td>
		<td class="text"><input name="newpassword2" id="newpassword2"
			type="password"></td>
	</tr>
	<% } %>
	<tr id="buttons-row">
		<td>&nbsp;</td>
		<td>
		<%if(explicit) { %> 
		<input name="changepin" id="changepin" type="submit"
			onclick="return check_pins(event);" value="Change PIN"> 
			<% } else {%>
		<input name="sessionstart" id="sessionstart" type="submit"
			onclick="return check_username()" value="Start Session">&nbsp;
		<input name="changepin" id="changepin" type="submit"
			onclick="return check_pins(event);" value="Change PIN">
			 <% } %>
		</td>
	</tr>

	<% if ((sessionID.length() > 0) && (!explicit)) { %>
	<tr id="image-row">
		<td colspan="2"><img id="turing"
			src="/<%=clientProps.getProperty("imagecontext", "proxy")%>/SCImage?sessionid=<%=sessionID%>" />
		</td>
	</tr>
	<% } %>
	<% if(error.length() > 0) { %>
	<tr id="error-row">
		<td colspan="2">
		<div><%=error %></div>
		
		</td>
	</tr>
	
	
	<% } %>
</table>
</form>
</body>
</html>
<%}  else {
	status = init;
	session.setAttribute("status", status);
	Properties props = (session.getAttribute("settings") != null ? (Properties) session.getAttribute("settings") : new Properties());
	String redirect = props.getProperty("redirect", "");
%>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<% if (redirect != "") { %>
        <meta http-equiv="Refresh" content="10; URL=<%=redirect%>">
<% } %>
        <link type="text/css" rel="stylesheet" href="./changepin.css">
        <title>PINsafe Change PIN Complete</title>
    </head>
    <body>
        <table id="box">
            <tr>
                <td class="message">
                    <%=PIN_CHANGE_SUCCESSFUL%>
<% if (redirect != "") { %>
                    <%=REDIRECTING_PROMPT%> <a href="<%=redirect%>"><%=REDIRECT_LINK_PROMPT%></a> <%=REDIRECTING_PROMPT2%>
<% } %>
                </td>
            </tr>
        </table>
    </body>
</html>
<%} %>


